---
- name: Install nginx-proxy from https://github.com/nginx-proxy/nginx-proxy
  block:
  - name: nginx-proxy directory present
    file: 
      path: "{{ nginx_proxy_path }}"
      state: directory
      
  - name: docker-compose.yml file present
    template:
      src: docker-compose.nginx-proxy.yml.j2
      dest: "{{ nginx_proxy_path }}/docker-compose.yml"
    register: docker_compose_template

  - name: Create the vhosts directory if it doesn't exist
    file:
      path: "{{ nginx_proxy_path }}/vhost"
      state: directory

  - name: Add a rewrite for /b/ URLs on legacy Greenlight instances
    ansible.builtin.copy:
      content: |
        location /b/ {
            rewrite ^/b(/.*)$ $1 last;
        }
      dest: "{{ nginx_proxy_path }}/vhost/default"

  - name: Update Docker containers
    command: docker-compose pull
    args:
      chdir: "{{ nginx_proxy_path }}"

  - name: nginx-proxy containers docker-compose up
    command: docker-compose up -d
    args:
      chdir: "{{ nginx_proxy_path }}"
    when: docker_compose_template is not changed

  - name: Rebuild containers when docker-compose.yml changes
    command: docker-compose up -d --force-recreate
    args:
      chdir: "{{ nginx_proxy_path }}"
    when: docker_compose_template is changed

  - name: Wait for the containers to start
    wait_for:
      timeout: 15

  - name: Check that the containers are running
    command: docker-compose ps
    args:
      chdir: "{{ nginx_proxy_path }}"
    register: nginx_proxy_docker_compose_ps

  tags:
    - nginx-proxy
...
